// C Source File
// Created 1/10/2001; 04:10:31 PM 

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

#define SPRITE_HEIGHT   8

short _ti89;                  // Produce .89Z File

unsigned char ball[] =
{0x3C,0x7E,0xFF,0xFF,0xFF,0xFF,0x7E,0x3C};
int paddle[] = 
{0x4000,0xE000,0xE000,0xE000,0xE000,0xE000,0xE000,0xE000
,0xE000,0xE000,0xE000,0xE000,0xE000,0xE000,0xE000,0x4000};

void delay(void) {//my delay is to slow down the program so you the operator can actually see what happens
  short int l1, l2 = 0;

  for (l1 = 0; l1 < 100; l1++) {
    for (l2 = 150; l2 >= 0; l2--) {
    }
  }
}

void intro(void) {
 clrscr();
 FontSetSys(F_8x10);
 DrawStr(45,1,"TI-SOFT's",A_NORMAL);
 DrawStr(62,11,"Pong",A_NORMAL);
 FontSetSys(F_4x6);
 DrawStr(50,30,"Press ESC to exit",A_NORMAL);
 DrawStr(48,39,"Buttons: Up, Down.",A_NORMAL);
 DrawStr(1,86,"Created by: Nitrocloud",A_NORMAL);
 DrawStr(1,93,"E-Mail: nitrocloud@netzero.net",A_NORMAL);
 FontSetSys(F_6x8);
 DrawStr(50,60,"Press Enter",A_NORMAL);
 ngetchx();
}

void draw(int x, int y) {
 Sprite8(x, y, SPRITE_HEIGHT, ball, LCD_MEM, SPRT_XOR);
}

void draw1(int y1) {
 Sprite16(1, y1, 16, paddle, LCD_MEM, SPRT_XOR);
}

void erase(int x, int y) {
 draw(x,y);
}

void erase1(int y1) {
 draw1(y1);
}

// Main Function
void _main(void)
{
 short int x,y,y1,a=0,c,b=0,out,score,speed;
 INT_HANDLER interrupt1;//make a varible for interrrupt one to be stored in.
 interrupt1 = GetIntVec(AUTO_INT_1);//save interrupt one to a variable
 out=0;
 x=10;
 y=4;
 c=2;
 y1=10;
 score=0;
 intro();
 clrscr();
 DrawStr(60,1,"Speed",A_NORMAL);
 FontSetSys(F_4x6);
 DrawStr(1,10,"F1 = Slow",A_NORMAL);
 DrawStr(1,17,"F2 = Medium",A_NORMAL);
 DrawStr(1,24,"F3 = Fast",A_NORMAL);
 FontSetSys(F_6x8);
 speed = ngetchx();
 if (speed==268){
 	a=1;
 	b=1;
 } else if (speed==269){
 	a=2;
 	b=2;
 } else if (speed==270){
 	a=3;
 	b=3;
 } else if (speed!= (268 || 269 || 270)){
 	a=2;
 	b=2;
 }
 SetIntVec(AUTO_INT_1,DUMMY_HANDLER);//sets the interupt handler for int1 to dummy handler
 clrscr();
 draw(x,y);
 draw1(y1);
 while (out!=1) {
  erase(x,y);
  erase1(y1);
  if (_rowread(~((short)(1<<0))) & (1<<0)) {
		 y1-=c;
 if (y1 < 1) {
  y1=1;
  }
  } else if (_rowread(~((short)(1<<0))) & (1<<2)) {
		 y1+=c;

 		if (y1 > 84) {
  		y1=84;
  	}
  } else  if (_rowread(~((short)(1<<6))) & (1<<0)) {
   out=1;
  }
   
  if (x < 1) {
   out=1;
  } 
  if (a<=2){
  	c=2;
  } else if (a==3){
  	c=4;
  } else if (a>=4){
  	c=6;
  }
  
  if (((y>=y1) | (y+8>=y1)) & ((y<=y1+8) | (y+8<=y1+8)) & (x<=3)){
  	b=b*-1;
  	a-=1;
  	score+=1;
  } else if (((y>=y1+9) | (y+8>=y1+9)) & ((y<=y1+16) | (y+8<=y1+16)) & (x<=3)){
  	b=b*-1;
  	a+=1;
  	score+=1;
  }
  
 x=x+b;
 if (x > 152) {
  b=-b;
 }
  y=y+a;

 if (y < 1) {
  a=a*-1;
 }

 if (y > 92) {
  a=a*-1;
 }
	draw1(y1);
  draw(x,y);
  delay();
  delay();
 }
 		SetIntVec(AUTO_INT_1, interrupt1);
		clrscr();
		printf("     You got %d points\n\n         Press ESC", score);
		ngetchx();
}
